#ifndef READRABUNDFILECOMMAND_H
#define READRABUNDFILECOMMAND_H
/*
 *  readrabundfilecommand.h
 *  Dotur
 *
 *  Created by Sarah Westcott on 1/2/09.
 *  Copyright 2009 Schloss Lab UMASS Amherst. All rights reserved.
 *
 */

#include <iostream>
#include <fstream>
#include "command.hpp"
#include "readmatrix.hpp"
#include "inputdata.h"

/* The read.rabund command parameter options are rabundfile and orderfile.  
The read.rabund command should be in the following format: 
read.rabund(rabundfile=yourRabundFile, orderfile=yourOrderFile). The rabundfile parameter is required.	*/

class GlobalData;

class ReadRAbundFileCommand : public Command {
public:
	ReadRAbundFileCommand();
	~ReadRAbundFileCommand();
	int execute();
	
private:
	GlobalData* globaldata;
	ReadMatrix* read;
	InputData* input;
	string filename;
};

#endif
