/*
 *  readsharedfilecommand.cpp
 *  Dotur
 *
 *  Created by Sarah Westcott on 1/2/09.
 *  Copyright 2009 Schloss Lab UMASS Amherst. All rights reserved.
 *
 */

#include "readsharedfilecommand.h"

//**********************************************************************************************************************
ReadSharedFileCommand::ReadSharedFileCommand(){
	try {
		globaldata = GlobalData::getInstance();
		filename = globaldata->inputFileName;	
		read = new ReadPhilFile(filename);
		//read in group map info.
		groupMap = new GroupMap(globaldata->getGroupFile());
	}
	catch(exception& e) {
		cout << "Standard Error: " << e.what() << " has occurred in the ReadSharedFileCommand class Function ReadSharedFileCommand. Please contact Pat Schloss at pschloss@microbio.umass.edu." << "\n";
		exit(1);
	}
	catch(...) {
		cout << "An unknown error has occurred in the ReadSharedFileCommand class function ReadSharedFileCommand. Please contact Pat Schloss at pschloss@microbio.umass.edu." << "\n";
		exit(1);
	}
}

//**********************************************************************************************************************

ReadSharedFileCommand::~ReadSharedFileCommand(){
	delete read;
	//delete groupMap;
}

//**********************************************************************************************************************

int ReadSharedFileCommand::execute(){
	try {
		read->read(&*globaldata); 
		groupMap->readMap();
		globaldata->gGroupmap = groupMap;
		return 0;
	}
	catch(exception& e) {
		cout << "Standard Error: " << e.what() << " has occurred in the ReadSharedFileCommand class Function execute. Please contact Pat Schloss at pschloss@microbio.umass.edu." << "\n";
		exit(1);
	}
	catch(...) {
		cout << "An unknown error has occurred in the ReadSharedFileCommand class function execute. Please contact Pat Schloss at pschloss@microbio.umass.edu." << "\n";
		exit(1);
	}
}

//**********************************************************************************************************************
