#ifndef READSHAREDFILECOMMAND_H
#define READSHAREDFILECOMMAND_H
/*
 *  readsharedfilecommand.h
 *  Dotur
 *
 *  Created by Sarah Westcott on 1/2/09.
 *  Copyright 2009 Schloss Lab UMASS Amherst. All rights reserved.
 *
 */

#include <iostream>
#include <fstream>
#include "command.hpp"
#include "readmatrix.hpp"
#include "inputdata.h"
#include "groupmap.h"


/* The read.shared command parameter options are listfile and groupfile.  
The read.shared command should be in the following format: 
read.shared(listfile=yourListFile, groupfile=yourGroupFile).  
The listfile parameter and groupfile paramaters are required. */		


class GlobalData;

class ReadSharedFileCommand : public Command {
public:
	ReadSharedFileCommand();
	~ReadSharedFileCommand();
	int execute();
	
private:
	GlobalData* globaldata;
	GroupMap* groupMap;
	ReadMatrix* read;
	InputData* input;
	string filename;
};

#endif
